float4x4 WorldViewMatrix;			// WorldViews
float4x4 LastWorldViewProjection;		// OWorldViewProjection
float4x4 Projection;			// Projection
float3 vEyePos;			// _W
float3 vLightDir;		// LightVector
float4 MaterialDiffuse;			// _F( }eA )
float4 MaterialAmbient;



//---------------------------------------------------------------------------------------------------------------------
// MotionBlurVertexShader
//
//
//---------------------------------------------------------------------------------------------------------------------
void VertexShader_MotionBlur(
      float4 Pos    : POSITION,
      float3 Normal : NORMAL,
      
      out float4 OutPos			: POSITION,
      out float4 OutColor		: COLOR0
){
	
	// Wϊ
	float4 NowVector = mul( Pos , WorldViewMatrix );					// ݂̍sWorldView
	float4 OldVector = mul( Pos , LastWorldViewProjection );			// Õt[̍sˉeϊ
	
	
	float4 v = NowVector - OldVector;									// xVector߂
	float3 n = mul( Normal , WorldViewMatrix );								// ViewWnɂZo
	
	bool bFront = ( 0 <= dot( n , v.xyz ) );	// xĂCheck

	float4 x = bFront ? NowVector : OldVector;				// _̕ɂĈʒu߂
	
	OutPos = mul( x , Projection );					// ˉeԂɕϊ
	
	// F
	OutColor = MaterialDiffuse * ( 0.7 * max( dot( vLightDir , Normal ) , 0 )// Diffuse
						+ MaterialAmbient );// Ambient
	
	// _isĂΕsA΂Ȃ瓧
	OutColor.a = bFront ? 1 : 0;
	

}

/*float4 MotionBlurPixelShader( float4 _Color : COLOR0 )  : COLOR
{
    return Tex2D * _Color;
}
*/

// ------------------------------------------------------------------------------------------------------------------
//
// eNjbN
//
// ------------------------------------------------------------------------------------------------------------------
technique StaticMotionBlur
{


    pass Pass0
    {
    //	CULL = CCW;
        // [Vu[
        VertexShader = compile vs_1_1 VertexShader_MotionBlur();
  //      PixelShader = compile ps_1_1 MotionBlurPixelShader();
    }
}