//----------------------------------------------------------------------------------------------------------------------------------
// Object̃}XN쐬Shader
// ˉeϊ_WɕxNgXJ[pĈړ
//----------------------------------------------------------------------------------------------------------------------------------


float4x4 WoldViewProjection;
float NormalScale;		// ̕ɂ炷ɍXJ[

// _VF[_
void FocusLineVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	out float4 Pos : POSITION
) {
	// _W̕ϊ
	float4 wvp_pos=mul(pos, WoldViewProjection);
	float4 wvp_normal=float4(mul(normal , (float3x3)WoldViewProjection) , 0);
	
	// ̕ɂ炷
	Pos = wvp_pos + normalize( wvp_normal ) * NormalScale * wvp_pos.w;
	
	// }XNf[^Z͕svȂ̂0
	Pos.z = 0;
}

// sNZVF[_
float4 FocusLinePS() : COLOR 
{
	return float4( 255 , 0 , 0 , 0 );
}


//---------------------------------------------------------------------------------------------------
// 쐬}XNf[^Rendering
//---------------------------------------------------------------------------------------------------
technique FocusLine
{
	pass P0
	{
		// wʃJO
		CullMode = CCW;
		
		// }XN̕`Ȃ̂ŐF͕sv
		ColorWriteEnable = 0;
		VertexShader = compile vs_1_1 FocusLineVS();
		PixelShader = compile ps_1_1 FocusLinePS();
	}
}


technique Mask
{
	pass P0
	{
		CullMode = CCW;
		VertexShader = compile vs_1_1 FocusLineVS();
		PixelShader = compile ps_1_1 FocusLinePS();
	}
}
